<template>
  <div class="p-2">
    <el-row :gutter="10">
      <el-col :span="5">
        <el-card>
          <template #header>
            <div class="card-header">分项系统</div>
          </template>
          <div>
            <el-input v-model="filterText" style="width: 200px" placeholder="请输入关键字" />
            <el-tree ref="treeRef" style="max-width: 600px; margin-top: 5px" class="filter-tree" :props="defaultProps"
              :data="treeData" node-key="id" default-expand-all highlight-current :expand-on-click-node="false"
              :filter-node-method="filterNode" @node-click="handleNodeClick" />
          </div>
        </el-card>
      </el-col>
      <el-col :span="19">
        <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
          :leave-active-class="proxy?.animate.searchAnimate.leave">
          <div v-show="showSearch" class="mb-[10px]">
            <el-card shadow="hover">
              <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="100px">
                <el-form-item label="设备类型名称" prop="deviceTypeId">
                  <el-select v-model="queryParams.deviceTypeId" placeholder="请选择设备类型名称">
                    <el-option v-for="dict in dictGroup.deviceTypeOptions" :key="dict.id" :label="dict.name"
                      :value="dict.id"></el-option>
                  </el-select>
                </el-form-item>
                <el-form-item label="型号" prop="xh">
                  <el-input v-model="queryParams.xh" placeholder="请输入型号" clearable @keyup.enter="handleQuery" />
                </el-form-item>
                <el-form-item>
                  <el-button type="primary" icon="Search" @click="handleQuery"> 搜索 </el-button>
                  <el-button icon="Refresh" @click="resetQuery"> 重置 </el-button>
                </el-form-item>
              </el-form>
            </el-card>
          </div>
        </transition>

        <el-card shadow="never">
          <template #header>
            <el-row :gutter="10" class="mb8">
              <right-toolbar v-model:showSearch="showSearch" @query-table="getList" />
            </el-row>
          </template>

          <el-table v-loading="loading" :data="deviceTypeList">
            <el-table-column label="设备类型名称" width="120" align="center">
              <template #default="scope">
                {{ formatDict(scope.row.deviceTypeId, 'deviceTypeOptions') }}
              </template>
            </el-table-column>
            <el-table-column label="品牌" align="center" prop="ext1.brand" />
            <el-table-column label="型号" align="center" prop="xh" />
            <el-table-column label="供应商" align="center" prop="productorId">
              <template #default="scope">
                {{ formatDict(scope.row.productorId, 'productorOptions') }}
              </template>
            </el-table-column>
            <el-table-column label="安全库存数量" align="center" prop="safeNum" width="150" />
            <el-table-column label="设置人" align="center" prop="ext1.setSafePersonName" width="120" />
            <el-table-column label="创建时间" align="center" prop="createTime" width="160" />
            <el-table-column label="操作" align="center" width="120" fixed="right" class-name="small-padding fixed-width">
              <template #default="scope">
                <el-button size="small" link type="primary" @click="handleStore(scope.row)">设置</el-button>
              </template>
            </el-table-column>
          </el-table>
          <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
            :total="total" @pagination="getList" />
        </el-card>
      </el-col>
    </el-row>

    <!-- 添加或修改设备类型信息对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="500px" append-to-body>
      <el-form ref="addFormRef" :model="form" label-width="110px">
        <el-form-item label="设备类型名称" prop="deviceTypeId">
          <el-select v-model="form.deviceTypeId" placeholder="请选择设备类型名称" disabled>
            <el-option v-for="dict in dictGroup.deviceTypeOptions" :key="dict.id" :label="dict.name"
              :value="dict.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="品牌" prop="ext1.brand">
          <el-input v-model="form.ext1.brand" placeholder="请输入品牌" disabled />
        </el-form-item>
        <el-form-item label="型号" prop="xh">
          <el-input v-model="form.xh" placeholder="请输入型号" disabled />
        </el-form-item>
        <el-form-item label="安全库存数量" prop="safeNum"
          :rules="[{ required: true, message: '安全库存数量不能为空', trigger: 'blur' }]">
          <el-input-number v-model="form.safeNum" style="width: 100%;" :min="1" controls-position="right" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm"> 确 定 </el-button>
          <el-button @click="cancel"> 取 消 </el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="StoreManage" lang="ts">
import {
  listDeviceType,
  updateDeviceTypeDetail,
  getDeviceSystemTree,
  getDeviceTypeDetailList
} from '@/api/deviceManage/deviceType';
import { listProductor } from '@/api/supplierManage/index';
import { deepClone } from '@/utils/index';
import { useUserStore } from '@/store/modules/user'
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const deviceTypeList = ref([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const queryFormRef = ref<ElFormInstance>();
const addFormRef = ref<ElFormInstance>();
const filterText = ref('');
const treeRef = ref<ElTreeInstance>();
const filterNode = (value: string, data) => {
  if (!value) return true;
  return data.name.includes(value);
};
watch(filterText, (val) => {
  treeRef.value!.filter(val);
});
const defaultProps = {
  children: 'children',
  label: 'name'
};
const treeData = ref([]);
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const dictGroup = reactive({
  deviceTypeOptions: [],
  productorOptions: []
});
const initFormData = {
  id: undefined,
  productorId: '',
  deviceTypeId: undefined,
  xh: null,
  remark: undefined,
  safeNum: undefined,
  ext1: <any>{
    brand: undefined,
    linkName: '',
    linkPhone: '',
    setSafePerson: '',
    setSafePersonName: '',
  },
  ext2: undefined
};
const formData = reactive({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    systemId: undefined,
    deviceTypeId: undefined,
    xh: undefined,
    params: {}
  }
});

const { queryParams, form } = toRefs(formData);
/** 查询设备类型信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await getDeviceTypeDetailList(queryParams.value);
  deviceTypeList.value = res.rows.map((item) => ({
    ...item,
    ext1: item.ext1 ? JSON.parse(item.ext1) : null
  }));
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = deepClone(initFormData);
  addFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};


const handleStore = (row) => {
  reset();
  Object.assign(form.value, row);
  dialog.visible = true;
  dialog.title = '设置安全库存数量';
};


/** 提交按钮 */
const submitForm = () => {
  addFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      const { id, ext1, safeNum } = form.value;
      ext1.setSafePerson = useUserStore().userId
      ext1.setSafePersonName = useUserStore().nickname
      buttonLoading.value = true
      await updateDeviceTypeDetail({
        id,
        ext1: JSON.stringify(ext1),
        safeNum
      })
      buttonLoading.value = false
      dialog.visible = false;
      proxy?.$modal.msgSuccess('设置成功');
      getList();
    }
  });
};


const getTreeData = async () => {
  getDeviceSystemTree({}).then(({ code, rows }) => {
    if (code === 200) {
      treeData.value = convertToTree(rows);
      if (treeData.value.length === 0) {
        treeData.value = [];
      }
    }
  });
};
const convertToTree = (list) => {
  let map = new Map();
  let root = [];
  for (let item of list) {
    map.set(item.id, { ...item });
  }
  for (let item of list) {
    if (item.parentId !== 0) {
      let parent = map.get(item.parentId);
      if (!parent.children) {
        parent.children = [];
      }
      parent.children.push(map.get(item.id));
    } else {
      root.push(map.get(item.id));
    }
  }
  return root;
};
const findNameWithParents = (data, idToFind, parentName = '') => {
  for (let item of data) {
    let fullName = parentName ? `${parentName}/${item.name}` : item.name;
    if (item.id === idToFind) {
      return fullName;
    }
    if (item.children && Array.isArray(item.children)) {
      let result = findNameWithParents(item.children, idToFind, fullName);
      if (result) {
        return result;
      }
    }
  }
  return null; // 如果没有找到对应的 ID，则返回 null
};
const getDeviceTypeList = () => {
  listDeviceType({}).then(({ code, rows }) => {
    if (code === 200) {
      dictGroup.deviceTypeOptions = rows;
    }
  });
};
const getProductorList = () => {
  listProductor({}).then(({ code, rows }) => {
    if (code === 200) {
      dictGroup.productorOptions = rows;
    }
  });
};
const handleNodeClick = (data, node) => {
  queryParams.value.systemId = data.id;
  handleQuery();
};
const formatDict = (val, option: string) => {
  let label = '';
  dictGroup[option].forEach((item) => {
    if (val === item.id) {
      label = item.name;
    }
  });
  return label;
};
onMounted(() => {
  getList();
  getTreeData();
  getDeviceTypeList();
  getProductorList();
});
</script>
<style lang="scss" scoped></style>
